<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// File: $Id: pnuserapi.php,v 1.3 2003/02/11 03:22:42 timax Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (webmaster@envolution.com)
// http://www.envolution.com
// Envolution Content Mangement System - http://www.envolution.com
//
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please read the docs/license.txt or visit
// http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Filename:    Encompass Theme Engine                pnuserapi.php
// Author:        Brian K. Virgin
// Version:        0.926
// Purpose:        Encompass Engine User API
// ----------------------------------------------------------------------------
//
// ----------------------------------------------------------------------------


//////
// Create the Encompass object
// @access        public
// @author        mh7
// @since        0.911        02-04-2002
// @param        none
// @return        object $engine Encompass Engine object
function encompass_userapi_init()
{
    if (!class_exists('Encompass'))
    {
        // Get Encompass module info
        $modinfo = pnModGetInfo(pnModGetIDFromName('Encompass'));
        if (!empty($modinfo))
        {
            // Load the Encompass Engine class
            include_once("modules/".$modinfo['directory']."/pnclasses/Encompass.php");
        }
    }

    $engine = new Encompass;

    // Return the Encompass object
    return $engine;
}


////
// Initialze the DuskyBlue Theme System
// @access        private
// @author        mh7
// @since        0.911        02-04-2002
// @param        string $module the module calling the DTS
// @param        string $path the path to the templates
// @return        object $DTS DuskyBlue Theme System object
function encompass_userapi_dtsInit($args)
{
    // Extract our parameters
    extract($args);

    // Argument verification
    if (empty($module) || empty($path))
    {
        // Arguement error
        pnSessionSetVar('errormsg', _ENARGSERROR);
        return false;
    }

    // Loadup the DuskyBlue Theme System
    if (!class_exists('Smarty'))
    {
        // Get Encompass module info
        $modinfo = pnModGetInfo(pnModGetIDFromName('Encompass'));

        if (!empty($modinfo))
        {
            // Load the DTS (Smarty) Class
            include_once("modules/".$modinfo['directory']."/pnclasses/Smarty.class.php");
        } else {
            // No Encompass module info
            pnSessionSetVar('errormsg', _ENAPILOADFAILED);
        }
    }

    // Setup DTS Main Settings
    $DTS                       = new Smarty;
    $DTS->compile_check        = true;                    // check for updated templates?
    $DTS->force_compile        = false;                   // force compile template always?
    $DTS->debugging            = false;                   // debugging on/off
    $DTS->left_delimiter       = "[-";                    // begin holder tag (be nice to others)
    $DTS->right_delimiter      = "-]";                    // end holder tag
    $DTS->config_dir           = "$path";                 // default configs path (theme|module)
    $DTS->template_dir         = "$path/templates";       // default directory for templates
  //  $DTS->compile_dir          = "$path/xcache";          // cache directory (compiled templates)
    $DTS->compile_dir          = "xcache/$module";          // cache directory (compiled templates)
    // Uncomment these lines to enable the Cache
    // @note        NOT FULLY IMPLEMENTED
    //$DTS->caching          = true;                    // use HTML cache system?
    //$DTS->cache_dir        = "$path/cache";           // HTML cache directory

    // Return the DTS object
    return $DTS;
}


////
// Initialize DuskyBlue Theme System for modules
// @access        public
// @author        mh7
// @since        0.911        02-04-2002
// @param        string $module module calling Encompass
// @param        string $template the template file to use
// @return        object $DTS DuskyBlue Theme System object
// @note        NOT FULLY IMPLEMENTED
function encompass_userapi_modInit($args)
{
    // Extract our parameters
    extract($args);

    // Verification
    if (empty($module) || empty($template))
    {
        // Arguement error
        pnSessionSetVar('errormsg', _ENARGSERROR);
        return false;
    }

    // Determine which Theme to use
    if (pnUserLoggedIn())
    {
        // Use the users Theme
        $theme = pnUserGetTheme();
    } else {
        // Use the sites theme
        $theme = pnConfigGetVar('Default_Theme');
    }

    // FIXED: <apathy>		Added smart class check to instantiate smarty class
    // Loadup the DuskyBlue Theme System
    if (!class_exists('Smarty'))
    {
        // Get Encompass module info
        $modinfo = pnModGetInfo(pnModGetIDFromName('Encompass'));

        if (!empty($modinfo))
        {
            // Load the DTS (Smarty) Class
            include_once("modules/".$modinfo['directory']."/pnclasses/Smarty.class.php");
        } else {
            // No Encompass module info
            pnSessionSetVar('errormsg', _ENAPILOADFAILED);
        }
    }

    // Get the calling modules info
    $modinfo = pnModGetInfo(pnModGetIDFromName($module));

    // Setup the default module template path
    $tplpath = "modules/".$modinfo['directory']."/pntemplates";

    // Check to see if a customized template is specified
    // mh7: this section yet to be finished
    if (file_exists("themes/$theme/templates/$template"))
    {
        $tplpath = "themes/$theme/templates";
    }

    // Setup DTS Main Settings
    $DTS = new Smarty;
    $DTS->compile_check        = true;                      // check for updated templates?
    $DTS->force_compile        = false;                     // force compile template always?
    $DTS->debugging            = false;                     // debugging on/off
    $DTS->left_delimiter       = "[-";                      // begin holder tag (be nice to others)
    $DTS->right_delimiter      = "-]";                      // end holder tag
    $DTS->config_dir           = "themes/$theme/config";    // default configs path (theme|module)
    $DTS->template_dir         = "$tplpath";                // default directory for templates
    $DTS->compile_dir          = "themes/$theme/xcache";    // cache directory (compiled templates)

    // Return the DTS Object
    return $DTS;
}


////
// Initialize Encompass for Themes
// @access        public
// @author        mh7
// @since        0.911        02-04-2002
// @param        string $skin the skin name we are to use
// @return        object $DTS the DuskyBlue Theme System object
// @see            encompass_userapi_dtsInit()
function encompass_userapi_themeInit($args)
{
    // Extract our parameters
    extract($args);

    // Verification
    if (empty($skin))
    {
        // Determine which Theme to use
        $skin = pnModAPIFunc('Encompass','user','getSkinName');
    }

    // Setup the Theme template path
    $tplpath = "themes/$skin";

    // Return the DTS object with proper paths
    return pnModAPIFunc('Encompass', 'user', 'dtsInit',
                            array('module'    => $skin,
                                'path'        => $tplpath));
}


////
// Get the active skin ID from the database
// @access        private
// @author        mh7
// @since        0.911        02-04-2002
// @param        string $skin the skin name
// @return        integer $result->fields[0] the skin ID
function encompass_userapi_getSkinID($args)
{
    // Extract our parameters
    extract($args);

    // Argument verification
    if (empty($skin))
    {
        $skin = pnModAPIFunc('Encompass','user','getSkinName');
    }

    // Grab the Skin's ID from the db
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Define the table & column
    $table = $pntable['theme_skins'];
    $column = &$pntable['theme_skins_column'];

    $query = "SELECT $column[skin_id]
            FROM $table
            WHERE $column[name]='$skin'
            AND $column[is_active]='1'
            LIMIT 1";

    // Execute the query
    $result = $dbconn->Execute($query);

    // If no matches found, return false to API
    if ($result->EOF)
    {
        return false;
    }

    // Return the result
    $result->Close();
    return $result->fields[0];
}


////
// Determine which skin to use
// @access        private
// @author        mh7
// @since        0.911        02-04-2002
// @param        none
// @return        string $skin name of the active skin
function encompass_userapi_getSkinName()
{
    // Determine which Theme to use
    if (pnUserLoggedIn())
    {
        // User logged in, use their Theme
        $skin = pnUserGetTheme();
    } else {
        // Use the sites Default Theme
        $skin = pnConfigGetVar('Default_Theme');
    }

    // If no matches found, return false to API
    if (empty($skin))
    {
        return false;
    }

    // Return the results
    return $skin;
}


////
// Fetch BG and Text Colors from the dB for the skin [legacy support]
// @access        private
// @author        mh7
// @since        0.911        02-04-2002
// @param        integer $skinid the ID of the skin to fetch colors for
// @return        array $colors the list of active colors for the skin
function encompass_userapi_getSkinColors($args)
{
    // Extract our parameters
    extract($args);

    // Setup the database object
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    // Verify the skins ID, assign default if null
    if (empty($skinid))
    {
        $skinid = pnModAPIFunc('Encompass','user','getSkinID');
    }

    // Setup the databse column pointers
    $column = &$pntable['theme_skins_column'];

    // Build the DB query
    $query = "SELECT $column[bgcolor1] AS \"bcolor1\",
                    $column[bgcolor2] AS \"bcolor2\",
                    $column[bgcolor3] AS \"bcolor3\",
                    $column[bgcolor4] AS \"bcolor4\",
                    $column[bgcolor5] AS \"bcolor5\",
                    $column[bgcolor6] AS \"bcolor6\",
                    $column[sepcolor] AS \"scolor\",
                    $column[textcolor1] AS \"tcolor1\",
                    $column[textcolor2] AS \"tcolor2\"
            FROM $pntable[theme_skins]
            WHERE $column[skin_id]='$skinid'";

    // Execute the query
    $result = $dbconn->Execute($query);

    // If no matches found, return false to the API
    if ($result->EOF)
    {
        return false;
    }

    // Setup array and return results
    $colors = $result->GetRowAssoc(false);
    $result->Close();
    return $colors;
}


?>