<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
//
// ----------------------------------------------------------------------
// POST-NUKE Content Management System
// Copyright (C) 2002 by the PostNuke Development Team.
// http://www.postnuke.com/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
// ----------------------------------------------------------------------
// Original Author of file: Stefan Koehler
// Purpose of file:  RteMulti administration display functions
// last change: 2002/10/02  WindMeUp    some more variables,
//                                      create/modify js_config.php automatically,
//                                      for activation TextArea-name is enough
// ----------------------------------------------------------------------

/**
 * the main administration function
 */
function rtemulti_admin_main()
{
    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_EDIT)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Return the output
    return $output->GetOutput();
}

/**
 * add new item
 */
function rtemulti_admin_new()
{
    // Create output object
    $output = new pnHTML();

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_ADD)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_RTEMULTIADD);

    // Start form
    $output->FormStart(pnModURL('rtemulti', 'admin', 'create'));

    // Add an authorisation ID
    $output->FormHidden('authid', pnSecGenAuthKey());

    $output->TableStart();

    // EditorType
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIEDITORTYPE));
    $row[] = $output->FormText('editortype', 'rtemulti', 32, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Module Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIMODNAME));
    $row[] = $output->FormText('modname', '', 32, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Variable Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIVARNAME));
    $row[] = $output->FormText('varname', '', 40, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Keystring (Search string)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIKEYSTRING));
    $row[] = $output->FormTextArea('keystring', '', 5, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Newstring (...change with)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTINEWSTRING));
    $row[] = $output->FormTextArea('newstring', '', 5, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Comments
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTICOMMENT));
    $row[] = $output->FormText('comment', '', 40, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    $output->TableEnd();

    // End form
    $output->Linebreak(2);
    $output->FormSubmit(_RTEMULTICREATE);
    $output->FormEnd();

    // Return the output
    return $output->GetOutput();
}

/**
 * This is a standard function that is called with the results of the
 * form supplied by rtemulti_admin_new() to create a new item
 * @param $args['editortype'] which editor for use
 * @param $args['modname'] module-name for activation
 * @param $args['varname'] TEXTAREA-name (or: 'form' for FORM-Tag)
 * @param $args['keystring'] Searchstring (complete beginning FORM- or TEXTAREA-Tag, or any text-string)
 * @param $args['newstring'] New string (not neccassary for FORM- or TEXTAREA-Tag, or replacement of 'keystring')
 * @param $args['comment'] Comments (just for info)
 */
function rtemulti_admin_create($args)
{
    // Get parameters from whatever input we need
    list($rid,
                 $editortype,
                 $modname,
                 $varname,
                 $keystring,
                 $newstring,
                 $comment)= pnVarCleanFromInput('rid',
                                                                                 'editortype',
                                                                                 'modname',
                                                                                 'varname',
                                                                                 'keystring',
                                                                                 'newstring',
                                        'comment');

    extract($args);

    // Confirm authorisation code.
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('rtemulti', 'admin', 'view'));
        return true;
    }

    // Check arguments
    if (empty($modname)) {
        $output = new pnHTML();
        $output->Text(_RTEMULTIMODNAMEEMPTY);
        return $output->GetOutput();
    }

    // Load API
    if (!pnModAPILoad('rtemulti', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }

    // The API function is called
    $lid = pnModAPIFunc('rtemulti',
                        'admin',
                        'create',
                        array('editortype' => $editortype,
                              'modname' => $modname,
                              'varname' => $varname,
                              'keystring' => $keystring,
                              'newstring' => $newstring,
                              'comment' => $comment));

    if ($rid != false) {
        // Success
        pnSessionSetVar('statusmsg', _RTEMULTICREATED);
    }

    pnRedirect(pnModURL('rtemulti', 'admin', 'view'));

    // Return
    return true;
}

/**
 * modify an item
 * @param 'rid' the id of the link to be modified
 */
function rtemulti_admin_modify($args)
{
    // Get parameters from whatever input we need
    list($rid,
                 $editortype,
                 $modname,
                 $varname,
                 $keystring,
                 $newstring,
                 $comment,
         $obid)= pnVarCleanFromInput('rid',
                                     'obid');


    extract($args);

    if (!empty($obid)) {
        $rid = $obid;
    }

    // Create output object
    $output = new pnHTML();

    // Load API
    if (!pnModAPILoad('rtemulti', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    $link = pnModAPIFunc('rtemulti',
                         'user',
                         'get',
                         array('rid' => $rid));

    if ($link == false) {
        $output->Text(_RTEMULTINOSUCHLINK);
        return $output->GetOutput();
    }

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::Item', "$item[modname]::$rid", ACCESS_EDIT)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_RTEMULTIEDIT);

    // Start form
    $output->FormStart(pnModURL('rtemulti', 'admin', 'update'));

    // Add an authorisation ID
    $output->FormHidden('authid', pnSecGenAuthKey());

    // Add a hidden variable for the link id
    $output->FormHidden('rid', pnVarPrepForDisplay($rid));

    $output->TableStart();

    // EditorType
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIEDITORTYPE));
    $row[] = $output->FormText('editortype', $link['editortype'], 32, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Module Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIMODNAME));
    $row[] = $output->FormText('modname', $link['modname'], 32, 100);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Variable Name
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIVARNAME));
    $row[] = $output->FormText('varname', $link['varname'], 40, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Keystring (Search string)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIKEYSTRING));
    $row[] = $output->FormTextArea('keystring', $link['keystring'], 5, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Newstring (...change with)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTINEWSTRING));
    $row[] = $output->FormTextArea('newstring', $link['newstring'], 5, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Comments
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTICOMMENT));
    $row[] = $output->FormText('comment', $link['comment'], 40, 200);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    $output->TableEnd();

    // End form
    $output->Linebreak(2);
    $output->FormSubmit(_RTEMULTIUPDATE);
    $output->FormEnd();

    // Return the output that has been generated by this function
    return $output->GetOutput();
}


/**
 * This is a standard function that is called with the results of the
 * form supplied by rtemulti_admin_modify() to update a current item
 * @param $args['editortype'] which editor for use
 * @param $args['modname'] module-name for activation
 * @param $args['varname'] TEXTAREA-name (or: 'form' for FORM-Tag)
 * @param $args['keystring'] Searchstring (complete beginning FORM- or TEXTAREA-Tag, or any text-string)
 * @param $args['newstring'] New string (not neccassary for FORM- or TEXTAREA-Tag, or replacement of 'keystring')
 * @param $args['comment'] Comments (just for info)
 */
function rtemulti_admin_update($args)
{
    // Get parameters from whatever input we need
    list($rid,
                 $editortype,
                 $modname,
                 $varname,
                 $keystring,
                 $newstring,
                 $comment)= pnVarCleanFromInput('rid',
                                                                                 'editortype',
                                                                                 'modname',
                                                                                 'varname',
                                                                                 'keystring',
                                                                                 'newstring',
                                        'comment');

    extract($args);

    if (!empty($obid)) {
        $rid = $obid;
    }

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('rtemulti', 'admin', 'view'));
        return true;
    }

    // Check arguments
    if (empty($modname)) {
        $output = new pnHTML();
        $output->Text(_RTEMULTIMODNAMEEMPTY);
        return $output->GetOutput();
    }

    // Load API
    if (!pnModAPILoad('rtemulti', 'admin')) {
        pnSessionSetVar('errormsg', _LOADFAILED);
        return $output->GetOutput();
    }

    if(pnModAPIFunc('rtemulti',
                    'admin',
                    'update',
                    array('rid' => $rid,
                          'editortype' => $editortype,
                          'modname' => $modname,
                          'varname' => $varname,
                          'keystring' => $keystring,
                          'newstring' => $newstring,
                          'comment' => $comment))) {
        // Success
        pnSessionSetVar('statusmsg', _RTEMULTIUPDATED);
    }

    pnRedirect(pnModURL('rtemulti', 'admin', 'view'));

    // Return
    return true;
}

/**
 * delete item
 * @param 'rid' the id of the item to be deleted
 * @param 'confirmation' confirmation that this item can be deleted
 */
function rtemulti_admin_delete($args)
{
    // Get parameters from whatever input we need
    list($rid,
         $obid,
         $confirmation) = pnVarCleanFromInput('rid',
                                              'obid',
                                              'confirmation');
    extract($args);

     if (!empty($obid)) {
         $lid = $obid;
     }

    // Load API
    if (!pnModAPILoad('rtemulti', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The user API function is called
    $link = pnModAPIFunc('rtemulti',
                         'user',
                         'get',
                         array('rid' => $rid));

    if ($link == false) {
        $output->Text(_RTEMULTINOSUCHITEM);
        return $output->GetOutput();
    }

    // Security check
    if (!pnSecAuthAction(0, 'RteMulti::Item', "$item[modname]::$rid", ACCESS_DELETE)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Check for confirmation.
    if (empty($confirmation)) {
        // No confirmation yet

        // Create output object
        $output = new pnHTML();

        // Add menu to output
        $output->SetInputMode(_PNH_VERBATIMINPUT);
        $output->Text(rtemulti_adminmenu());
        $output->SetInputMode(_PNH_PARSEINPUT);

        // Title
        $output->Title(_RTEMULTIDELETE . " $item[modname] - $item[varname]");

        // Add confirmation to output.
        $output->ConfirmAction(_RTEMULTICONFIRMDELETE,
                               pnModURL('rtemulti',
                                        'admin',
                                        'delete'),
                               _RTEMULTICANCELDELETE,
                               pnModURL('rtemulti',
                                        'admin',
                                        'view'),
                               array('rid' => $rid));

        // Return the output that has been generated by this function
        return $output->GetOutput();
    }

    // If we get here it means that the user has confirmed the action

    // Confirm authorisation code
    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('rtemulti', 'admin', 'view'));
        return true;
    }

    // Load API
    if (!pnModAPILoad('rtemulti', 'admin')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The API function is called
    if (pnModAPIFunc('rtemulti',
                     'admin',
                     'delete',
                     array('rid' => $rid))) {
        // Success
        pnSessionSetVar('statusmsg', _RTEMULTIDELETED);
    }

    pnRedirect(pnModURL('rtemulti', 'admin', 'view'));

    // Return
    return true;
}

/**
 * view items
 */
function rtemulti_admin_view()
{
    // Get parameters from whatever input we need
    $startnum = pnVarCleanFromInput('startnum');

    // Create output object
    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_EDIT)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    // Add menu to output
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    // Title
    $output->Title(_RTEMULTIVIEW);

    // Load API
    if (!pnModAPILoad('rtemulti', 'user')) {
        $output->Text(_LOADFAILED);
        return $output->GetOutput();
    }

    // The user API function is called
    $links = pnModAPIFunc('rtemulti',
                          'user',
                          'getall',
                          array('rid' => $rid,
                                                                  'editortype' => $editortype,
                                                                'modname' => $modname,
                                                                'varname' => $varname,
                                                                'keystring' => $keystring,
                                                                'newstring' => $newstring,
                                                                'comment' => $comment,
                                'numitems' => pnModGetVar('rtemulti',
                                                          'itemsperpage')));

    if (empty($links)) {
        $output->Text(_RTEMULTINOLINKS);
        return $output->GetOutput();
    }

    // Start output table
    $output->TableStart('',
                        array(_RTEMULTIEDITORTYPE,
                              _RTEMULTIMODNAME,
                              _RTEMULTIVARNAME,
                              _RTEMULTIKEYSTRING,
                              _RTEMULTINEWSTRING,
                              _RTEMULTICOMMENT,
                              _RTEMULTIOPTIONS),
                        3);

    foreach ($links as $link) {

        $row = array();

        if (pnSecAuthAction(0, 'RteMulti::', "$link[modname]::$link[rid]", ACCESS_READ)) {

            $row[] = pnVarPrepForDisplay($link['editortype']);
            $row[] = pnVarPrepForDisplay($link['modname']);
            $row[] = pnVarPrepForDisplay($link['varname']);
            $row[] = pnVarPrepForDisplay(substr($link['keystring'],0,24));
            $row[] = pnVarPrepForDisplay(substr($link['newstring'],0,24));
            if (empty($link['comment'])) {
                $row[] = '&nbsp;';
            } else {
                $row[] = pnVarPrepForDisplay(substr($link['comment'],0,14));
            }

            // Options for the link

            $options = array();
            $output->SetOutputMode(_PNH_RETURNOUTPUT);
            if (pnSecAuthAction(0, 'RteMulti::', "$link[modname]::$link[rid]", ACCESS_EDIT)) {
                $options[] = $output->URL(pnModURL('rtemulti',
                                                   'admin',
                                                   'modify',
                                                   array('rid' => $link['rid'])),
                                          _EDIT);
                if (pnSecAuthAction(0, 'RteMulti::', "$item[modname]::$link[rid]", ACCESS_DELETE)) {
                    $options[] = $output->URL(pnModURL('rtemulti',
                                                       'admin',
                                                       'delete',
                                                       array('rid' => $link['rid'])),
                                              _DELETE);
                }
            }

            $options = join(' | ', $options);
            $output->SetInputMode(_PNH_VERBATIMINPUT);
            $row[] = $output->Text($options);
            $output->SetOutputMode(_PNH_KEEPOUTPUT);
            $output->TableAddRow($row);
            $output->SetInputMode(_PNH_PARSEINPUT);
        }
    }
    $output->TableEnd();

    // Display pager
    $output->Pager($startnum,
                    pnModAPIFunc('rtemulti', 'user', 'countitems'),
                    pnModURL('rtemulti',
                             'admin',
                             'view',
                            array('startnum' => '%%')),
                    pnModGetVar('rtemulti', 'itemsperpage'));


    // Return the output that has been generated by this function
    return $output->GetOutput();
}

/**
 * modify configuration
 */
function rtemulti_admin_modifyconfig()
{
    $output = new pnHTML();

    if (!pnSecAuthAction(0, 'RteMulti::', '::', ACCESS_ADMIN)) {
        $output->Text(_RTEMULTINOAUTH);
        return $output->GetOutput();
    }

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->Text(rtemulti_adminmenu());
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->Title(_RTEMULTIMODIFYCONFIG);

    $output->FormStart(pnModURL('rtemulti', 'admin', 'updateconfig'));

    $output->FormHidden('authid', pnSecGenAuthKey());

    $output->TableStart();

    // Generell settings (header) for Filemanager
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Title(pnVarPrepForDisplay(_SUBJECTSGENERELLSETTING));
    //$row[] = $output->Text(pnVarPrepForDisplay('--'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // max filesize for Subjects-filemanager
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_SUBMAXFILESIZE));
    $row[] = $output->FormText('submaxfilesize', pnModGetVar('Subjects', 'submaxfilesize'), 15, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // max total size of all files in directory [Subjects-filemanager]
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_SUBMAXHDDSPACE));
    $row[] = $output->FormText('submaxhddspace', pnModGetVar('Subjects', 'submaxhddspace'), 15, 30);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // add any file names to this array which should remain invisible [Subjects-filemanager]
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_SUBHIDDENFILES));
    $row[] = $output->FormText('subhiddenfiles', pnModGetVar('Subjects', 'subhiddenfiles'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // add any file names to this array which should remain invisible [Subjects-filemanager]
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_SUBHIDDENDIRS));
    $row[] = $output->FormText('subhiddendirs', pnModGetVar('Subjects', 'subhiddendirs'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // add the extensions of file types that you would like to be able to edit [Subjects-filemanager]
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_SUBEDITEXTENSIONS));
    $row[] = $output->FormText('subeditextensions', pnModGetVar('Subjects', 'subeditextensions'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // add the extensions of image file type [Subjects-filemanager]
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_SUBIMAGEEXTENSIONS));
    $row[] = $output->FormText('subimageextensions', pnModGetVar('Subjects', 'subimageextensions'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // upload path for Filemananger (don't know where I can find a global for that!!!)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_SUBPAGESPATH));
    $row[] = $output->FormText('subpagespath', pnModGetVar('Subjects', 'subpagespath'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    $output->TableEnd();
    $output->Linebreak(1);
    $output->FormSubmit(_SUBUPDATECONFIG);
    $output->HorizontalRule();
    $output->TableStart();

    // Generell settings (header)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Title(pnVarPrepForDisplay(_RTEMULTIGENERELLSETTING));
    //$row[] = $output->Text(pnVarPrepForDisplay('--'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // root path of the Postnuke-Installation (don't know where I can find a global for that!!!)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIPNROOTPATH));
    $row[] = $output->FormText('pnrootpath', pnModGetVar('RteMulti', 'pnrootpath'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // home of the RTE kernel-scripts (possible: under ContentExpress or anywhere)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIEDITORPATH));
    $row[] = $output->FormText('editorpath', pnModGetVar('RteMulti', 'editorpath'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Image upload path (complete server directory)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGEUPLOADDIR));
    $row[] = $output->FormText('image_upload_dir', pnModGetVar('RteMulti', 'image_upload_dir'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Image path (relativ to PN)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGEPATH));
    $row[] = $output->FormText('image_path', pnModGetVar('RteMulti', 'image_path'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Acceptable file types
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGEACCEPT));
    $row[] = $output->FormText('image_accept', pnModGetVar('RteMulti', 'image_accept'), 50, 250);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Acceptable filesize for uploading images in bytes
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGEFILESIZE));
    $row[] = $output->FormText('image_filesize', pnModGetVar('RteMulti', 'image_filesize'), 10, 15);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // overall activation of RTE
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEENABLE));
    $row[] = $output->FormCheckbox('RteEnable', pnModGetVar('RteMulti', 'RteEnable'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // right-mouse-button dialog-box for RTE-textfields (non-visual)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEDIALOGBOX));
    $row[] = $output->FormCheckbox('RteDialogBox', pnModGetVar('RteMulti', 'RteDialogBox'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // right-mouse-button dialog-box for RTE-textfields (non-visual)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEVISUALBOX));
    $row[] = $output->FormCheckbox('RteVisualBox', pnModGetVar('RteMulti', 'RteVisualBox'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // RTE-iframe size
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEDIMENSION));
        $row[] = $output->TableStart('','','0');
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEHEIGHT));
    $row[] = $output->FormText('RteHeight', pnModGetVar('RteMulti', 'RteHeight'), 6, 6);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEWIDTH));
    $row[] = $output->FormText('RteWidth', pnModGetVar('RteMulti', 'RteWidth'), 6, 6);
        $row[] = $output->TableEnd();
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // if RTE activated, how should it works
        // (-1= only pop-up over right mouse button for activated modules
        // ( 0= only on Klick in TEXAREA with YES/NO-selection (doesn't work yet)
        // ( 2= only for activated TEXTAREAs
        // ( 1= for all TEXTAREAs, without checking which is activated
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEACTIVATE));
        $row[] = $output->TableStart('','','0');
    $row[] = $output->FormCheckbox('RteActivate', (pnModGetVar('RteMulti', 'RteActivate')=='-1'),'-1','radio','1');
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEDISABLE));
    //$row[] = $output->Text(pnVarPrepForDisplay('Auf Klick: '));
    //$row[] = $output->FormCheckbox('RteActivate', (pnModGetVar('RteMulti', 'RteActivate')=='0'),'0','radio','2');
    $row[] = $output->FormCheckbox('RteActivate', (pnModGetVar('RteMulti', 'RteActivate')=='2'),'2','radio','3');
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEACTIVE));
    $row[] = $output->FormCheckbox('RteActivate', (pnModGetVar('RteMulti', 'RteActivate')=='1'),'1','radio','4');
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIRTEOVERALL));
        $row[] = $output->TableEnd();
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // activate/deactivate some HTML-tags for security-reason (<object, <iframe, <script, etc.)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTISECURITY));
        $row[] = $output->TableStart('','','0');
    $row[] = $output->FormCheckbox('RteSecurity', pnModGetVar('RteMulti', 'RteSecurity'));
    $row[] = $output->Text(pnVarPrepForDisplay(_RTESECURITY));
        $row[] = $output->TableEnd();
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    $output->TableEnd();
    $output->Linebreak(1);
    $output->FormSubmit(_RTEMULTIUPDATECONFIG);
    $output->HorizontalRule();
    $output->TableStart();

    // all other settings (header)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Title(pnVarPrepForDisplay(_RTEMULTIDEFAULTSETTING));
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEMULTIFORWHO));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // all other settings (header)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Title(pnVarPrepForDisplay(' '));
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEMULTIFORUSER));
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEMULTIFORADMIN));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // First toolbar
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEMULTIFIRSTBAR));
    $row[] = $output->FormCheckbox('FirstBar', pnModGetVar('RteMulti', 'FirstBar'));
    $row[] = $output->FormCheckbox('AdmFirstBar', pnModGetVar('RteMulti', 'AdmFirstBar'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Post-button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIPOSTIT));
    $row[] = $output->FormCheckbox('PostIt', pnModGetVar('RteMulti', 'PostIt'));
    $row[] = $output->FormCheckbox('AdmPostIt', pnModGetVar('RteMulti', 'AdmPostIt'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // copy/paste buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTICOPYPASTE));
    $row[] = $output->FormCheckbox('CopyPaste', pnModGetVar('RteMulti', 'CopyPaste'));
    $row[] = $output->FormCheckbox('AdmCopyPaste', pnModGetVar('RteMulti', 'AdmCopyPaste'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // insert/delete buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIINSERTDELETE));
    $row[] = $output->FormCheckbox('InsertDelete', pnModGetVar('RteMulti', 'InsertDelete'));
    $row[] = $output->FormCheckbox('AdmInsertDelete', pnModGetVar('RteMulti', 'AdmInsertDelete'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // url-insert/delete buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTILINKS));
    $row[] = $output->FormCheckbox('Links', pnModGetVar('RteMulti', 'Links'));
    $row[] = $output->FormCheckbox('AdmLinks', pnModGetVar('RteMulti', 'AdmLinks'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // image-uploader button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGEUP));
    $row[] = $output->FormCheckbox('ImageUp', pnModGetVar('RteMulti', 'ImageUp'));
    $row[] = $output->FormCheckbox('AdmImageUp', pnModGetVar('RteMulti', 'AdmImageUp'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // image-url button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIIMAGE));
    $row[] = $output->FormCheckbox('Image', pnModGetVar('RteMulti', 'Image'));
    $row[] = $output->FormCheckbox('AdmImage', pnModGetVar('RteMulti', 'AdmImage'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // table-insert/edit buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTITABLES));
    $row[] = $output->FormCheckbox('Tables', pnModGetVar('RteMulti', 'Tables'));
    $row[] = $output->FormCheckbox('AdmTables', pnModGetVar('RteMulti', 'AdmTables'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // horizontal rule button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIHORIZONTAL));
    $row[] = $output->FormCheckbox('Horizontal', pnModGetVar('RteMulti', 'Horizontal'));
    $row[] = $output->FormCheckbox('AdmHorizontal', pnModGetVar('RteMulti', 'AdmHorizontal'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // smilies button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTISMILIES));
    $row[] = $output->FormCheckbox('Smilies', pnModGetVar('RteMulti', 'Smilies'));
    $row[] = $output->FormCheckbox('AdmSmilies', pnModGetVar('RteMulti', 'AdmSmilies'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // special chars  button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTICHARSET));
    $row[] = $output->FormCheckbox('CharSet', pnModGetVar('RteMulti', 'CharSet'));
    $row[] = $output->FormCheckbox('AdmCharSet', pnModGetVar('RteMulti', 'AdmCharSet'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // textbar (2nd toolbar)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEMULTITEXTBAR));
    $row[] = $output->FormCheckbox('TextBar', pnModGetVar('RteMulti', 'TextBar'));
    $row[] = $output->FormCheckbox('AdmTextBar', pnModGetVar('RteMulti', 'AdmTextBar'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Text-formating buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTITEXTFORMAT));
    $row[] = $output->FormCheckbox('TextFormat', pnModGetVar('RteMulti', 'TextFormat'));
    $row[] = $output->FormCheckbox('AdmTextFormat', pnModGetVar('RteMulti', 'AdmTextFormat'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Text-justify buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTITEXTJUSTIFY));
    $row[] = $output->FormCheckbox('TextJustify', pnModGetVar('RteMulti', 'TextJustify'));
    $row[] = $output->FormCheckbox('AdmTextJustify', pnModGetVar('RteMulti', 'AdmTextJustify'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Text-list buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTITEXTLIST));
    $row[] = $output->FormCheckbox('TextList', pnModGetVar('RteMulti', 'TextList'));
    $row[] = $output->FormCheckbox('AdmTextList', pnModGetVar('RteMulti', 'AdmTextList'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Text-indent button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTITEXTINDENT));
    $row[] = $output->FormCheckbox('TextIndent', pnModGetVar('RteMulti', 'TextIndent'));
    $row[] = $output->FormCheckbox('AdmTextIndent', pnModGetVar('RteMulti', 'AdmTextIndent'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // History buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIHISTORY));
    $row[] = $output->FormCheckbox('History', pnModGetVar('RteMulti', 'History'));
    $row[] = $output->FormCheckbox('AdmHistory', pnModGetVar('RteMulti', 'AdmHistory'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Source button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTISOURCE));
    $row[] = $output->FormCheckbox('Source', pnModGetVar('RteMulti', 'Source'));
    $row[] = $output->FormCheckbox('AdmSource', pnModGetVar('RteMulti', 'AdmSource'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Stylebar (3rd toolbar)
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->BoldText(pnVarPrepForDisplay(_RTEMULTISTYLEBAR));
    $row[] = $output->FormCheckbox('StyleBar', pnModGetVar('RteMulti', 'StyleBar'));
    $row[] = $output->FormCheckbox('AdmStyleBar', pnModGetVar('RteMulti', 'AdmStyleBar'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Style button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTISTYLE));
    $row[] = $output->FormCheckbox('Style', pnModGetVar('RteMulti', 'Style'));
    $row[] = $output->FormCheckbox('AdmStyle', pnModGetVar('RteMulti', 'AdmStyle'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Font button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIFONT));
    $row[] = $output->FormCheckbox('Font', pnModGetVar('RteMulti', 'Font'));
    $row[] = $output->FormCheckbox('AdmFont', pnModGetVar('RteMulti', 'AdmFont'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Fontsize button
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTIFONTSIZE));
    $row[] = $output->FormCheckbox('FontSize', pnModGetVar('RteMulti', 'FontSize'));
    $row[] = $output->FormCheckbox('AdmFontSize', pnModGetVar('RteMulti', 'AdmFontSize'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    // Colour (foreground/background) buttons
    $row = array();
    $output->SetOutputMode(_PNH_RETURNOUTPUT);
    $row[] = $output->Text(pnVarPrepForDisplay(_RTEMULTICOLOUR));
    $row[] = $output->FormCheckbox('Colour', pnModGetVar('RteMulti', 'Colour'));
    $row[] = $output->FormCheckbox('AdmColour', pnModGetVar('RteMulti', 'AdmColour'));
    $output->SetOutputMode(_PNH_KEEPOUTPUT);
    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddrow($row, 'left');
    $output->SetInputMode(_PNH_PARSEINPUT);
    //$output->Linebreak(2);

    $output->TableEnd();
    $output->Linebreak(2);
    $output->FormSubmit(_RTETOOLBARUPDATECONFIG);
    $output->FormEnd();

    return $output->GetOutput();
}

/**
 * update configuration
 */
function rtemulti_admin_updateconfig()
{
    //$output->Linebreak(2);
    list(	$submaxfilesize,
			$submaxhddspace,
			$subhiddenfiles,
			$subhiddendirs,
			$subeditextensions,
			$subimageextensions,
			$subpagespath,
			$pnrootpath,
            $editorpath,
            $image_upload_dir,
            $image_path,
            $image_accept,
            $image_filesize,
            $RteEnable,
            $RteDialogBox,
            $RteVisualBox,
            $RteHeight,
            $RteWidth,
            $RteActivate,
            $RteSecurity,
            $FirstBar,
            $PostIt,
            $CopyPaste,
            $InsertDelete,
            $Links,
            $ImageUp,
            $Image,
            $Tables,
            $Horizontal,
            $Smilies,
            $CharSet,
            $TextBar,
            $TextFormat,
            $TextJustify,
            $TextList,
            $TextIndent,
            $History,
            $Source,
            $StyleBar,
            $Style,
            $Font,
            $FontSize,
            $Colour,
            $AdmFirstBar,
            $AdmPostIt,
            $AdmCopyPaste,
            $AdmInsertDelete,
            $AdmLinks,
            $AdmImageUp,
            $AdmImage,
            $AdmTables,
            $AdmHorizontal,
            $AdmSmilies,
            $AdmCharSet,
            $AdmTextBar,
            $AdmTextFormat,
            $AdmTextJustify,
            $AdmTextList,
            $AdmTextIndent,
            $AdmHistory,
            $AdmSource,
            $AdmStyleBar,
            $AdmStyle,
            $AdmFont,
            $AdmFontSize,
            $AdmColour         ) = pnVarCleanFromInput ('submaxfilesize',
														'submaxhddspace',
														'subhiddenfiles',
														'subhiddendirs',
														'subeditextensions',
														'subimageextensions',
														'subpagespath',
														'pnrootpath',
                                                        'editorpath',
                                                        'image_upload_dir',
                                                        'image_path',
                                                        'image_accept',
                                                        'image_filesize',
                                                        'RteEnable',
                                                        'RteDialogBox',
                                                        'RteVisualBox',
                                                        'RteHeight',
                                                        'RteWidth',
                                                        'RteActivate',
                                                        'RteSecurity',
                                                        'FirstBar',
                                                        'PostIt',
                                                        'CopyPaste',
                                                        'InsertDelete',
                                                        'Links',
                                                        'ImageUp',
                                                        'Image',
                                                        'Tables',
                                                        'Horizontal',
                                                        'Smilies',
                                                        'CharSet',
                                                        'TextBar',
                                                        'TextFormat',
                                                        'TextJustify',
                                                        'TextList',
                                                        'TextIndent',
                                                        'History',
                                                        'Source',
                                                        'StyleBar',
                                                        'Style',
                                                        'Font',
                                                        'FontSize',
                                                        'Colour',
                                                        'AdmFirstBar',
                                                        'AdmPostIt',
                                                        'AdmCopyPaste',
                                                        'AdmInsertDelete',
                                                        'AdmLinks',
                                                        'AdmImageUp',
                                                        'AdmImage',
                                                        'AdmTables',
                                                        'AdmHorizontal',
                                                        'AdmSmilies',
                                                        'AdmCharSet',
                                                        'AdmTextBar',
                                                        'AdmTextFormat',
                                                        'AdmTextJustify',
                                                        'AdmTextList',
                                                        'AdmTextIndent',
                                                        'AdmHistory',
                                                        'AdmSource',
                                                        'AdmStyleBar',
                                                        'AdmStyle',
                                                        'AdmFont',
                                                        'AdmFontSize',
                                                        'AdmColour'        );

    if (!pnSecConfirmAuthKey()) {
        pnSessionSetVar('errormsg', _BADAUTHKEY);
        pnRedirect(pnModURL('rtemulti', 'admin', 'view'));
        return true;
    }

    if (!isset($editorpath))        { $editorpath = 'modules/RteMulti/pneditor'; }
//    if (!isset($RteEnable))         { $RteEnable = 1; }

    pnModSetVar('Subjects', 'submaxfilesize', $submaxfilesize);
    pnModSetVar('Subjects', 'submaxhddspace', $submaxhddspace);
    pnModSetVar('Subjects', 'subhiddenfiles', $subhiddenfiles);
    pnModSetVar('Subjects', 'subhiddendirs', $subhiddendirs);
    pnModSetVar('Subjects', 'subeditextensions', $subeditextensions);
    pnModSetVar('Subjects', 'subimageextensions', $subimageextensions);
    pnModSetVar('Subjects', 'subpagespath', $subpagespath);

    pnModSetVar('rtemulti', 'pnrootpath', $pnrootpath);
    pnModSetVar('rtemulti', 'editorpath', $editorpath);
    pnModSetVar('rtemulti', 'image_upload_dir', $image_upload_dir);
    pnModSetVar('rtemulti', 'image_path', $image_path);
    pnModSetVar('rtemulti', 'image_accept', $image_accept);
    pnModSetVar('rtemulti', 'image_filesize', $image_filesize);
    pnModSetVar('rtemulti', 'RteEnable', $RteEnable);
    pnModSetVar('rtemulti', 'RteDialogBox', $RteDialogBox);
    pnModSetVar('rtemulti', 'RteVisualBox', $RteVisualBox);
    pnModSetVar('rtemulti', 'RteHeight', $RteHeight);
    pnModSetVar('rtemulti', 'RteWidth', $RteWidth);
    pnModSetVar('rtemulti', 'RteActivate', $RteActivate);
    pnModSetVar('rtemulti', 'RteSecurity', $RteSecurity);

    pnModSetVar('rtemulti', 'FirstBar', $FirstBar);
    pnModSetVar('rtemulti', 'PostIt', $PostIt);
    pnModSetVar('rtemulti', 'CopyPaste', $CopyPaste);
    pnModSetVar('rtemulti', 'InsertDelete', $InsertDelete);
    pnModSetVar('rtemulti', 'Links', $Links);
    pnModSetVar('rtemulti', 'ImageUp', $ImageUp);
    pnModSetVar('rtemulti', 'Image', $Image);
    pnModSetVar('rtemulti', 'Tables', $Tables);
    pnModSetVar('rtemulti', 'Horizontal', $Horizontal);
    pnModSetVar('rtemulti', 'Smilies', $Smilies);
    pnModSetVar('rtemulti', 'CharSet', $CharSet);

    pnModSetVar('rtemulti', 'TextBar', $TextBar);
    pnModSetVar('rtemulti', 'TextFormat', $TextFormat);
    pnModSetVar('rtemulti', 'TextJustify', $TextJustify);
    pnModSetVar('rtemulti', 'TextList', $TextList);
    pnModSetVar('rtemulti', 'TextIndent', $TextIndent);
    pnModSetVar('rtemulti', 'History', $History);
    pnModSetVar('rtemulti', 'Source', $Source);

    pnModSetVar('rtemulti', 'StyleBar', $StyleBar);
    pnModSetVar('rtemulti', 'Style', $Style);
    pnModSetVar('rtemulti', 'Font', $Font);
    pnModSetVar('rtemulti', 'FontSize', $FontSize);
    pnModSetVar('rtemulti', 'Colour', $Colour);

    pnModSetVar('rtemulti', 'AdmFirstBar', $AdmFirstBar);
    pnModSetVar('rtemulti', 'AdmPostIt', $AdmPostIt);
    pnModSetVar('rtemulti', 'AdmCopyPaste', $AdmCopyPaste);
    pnModSetVar('rtemulti', 'AdmInsertDelete', $AdmInsertDelete);
    pnModSetVar('rtemulti', 'AdmLinks', $AdmLinks);
    pnModSetVar('rtemulti', 'AdmImageUp', $AdmImageUp);
    pnModSetVar('rtemulti', 'AdmImage', $AdmImage);
    pnModSetVar('rtemulti', 'AdmTables', $AdmTables);
    pnModSetVar('rtemulti', 'AdmHorizontal', $AdmHorizontal);
    pnModSetVar('rtemulti', 'AdmSmilies', $AdmSmilies);
    pnModSetVar('rtemulti', 'AdmCharSet', $AdmCharSet);

    pnModSetVar('rtemulti', 'AdmTextBar', $AdmTextBar);
    pnModSetVar('rtemulti', 'AdmTextFormat', $AdmTextFormat);
    pnModSetVar('rtemulti', 'AdmTextJustify', $AdmTextJustify);
    pnModSetVar('rtemulti', 'AdmTextList', $AdmTextList);
    pnModSetVar('rtemulti', 'AdmTextIndent', $AdmTextIndent);
    pnModSetVar('rtemulti', 'AdmHistory', $AdmHistory);
    pnModSetVar('rtemulti', 'AdmSource', $AdmSource);

    pnModSetVar('rtemulti', 'AdmStyleBar', $AdmStyleBar);
    pnModSetVar('rtemulti', 'AdmStyle', $AdmStyle);
    pnModSetVar('rtemulti', 'AdmFont', $AdmFont);
    pnModSetVar('rtemulti', 'AdmFontSize', $AdmFontSize);
    pnModSetVar('rtemulti', 'AdmColour', $AdmColour);

    pnSessionSetVar('statusmsg', _RTEMULTIUPDATEDCONFIG);

        $aBuffer = explode(',',$image_accept);
        $image_accept_store = '';
        for($i=0; $i < count($aBuffer); $i++)
        {
                $image_accept_store .= '"'.trim($aBuffer[$i]).'",';
        }
// Create or modify js_config.php for the image-picker
    $d = ml_ftime(_DATETIMELONG);
    $content = "<?php // Generated: $d\n"
        ."// ----------------------------------------------------------------------\n"
                ."/**\n"
                ."This is the config-file for some defaults to setting up the imagePicker\n"
                ."The imagePicker is an enhancement for the Richtext-Editor\n"
                ."\n"
                ."Name: rte-config.php\n"
                ."Description: DON'T EDIT THIS FILE MANUALLY. IT WILL BE GENERATED AUTOMATICALLY\n"
                ."Author: Stefan Khler (s.koehler@prowings.de)\n"
                ."**/\n"
        ."// ----------------------------------------------------------------------\n"
                ."global \$IMG_ACCEPT;\n"
                ."\n"
		."define('PN_ROOT_PATH','$pnrootpath'); //Root-path of Postnuke (neccessary for including relative URLs in contents)\n"
                ."define('IMG_UPLOAD_SRC',''); //upload page (not used yet)\n"
                ."define('IMG_UPLOAD_LINK',''); //page to go after upload (not used yet)\n"
                ."define('IMG_UPLOAD_DIR','$image_upload_dir'); //default image upload location, if upload page is not specified\n"
                ."define('IMG_PATH','$image_path'); //relative path from document to images, to be view from document\n"
                ."define('MAX_FILESIZE','$image_filesize'); //max. filesize in bytes for uploading images \n"
                ."\$IMG_ACCEPT = array($image_accept_store); //acceptable types\n"
        ."// ----------------------------------------------------------------------\n"
        .'?'.'>'
    ;
    // I can't seem to get around the stupid PHP file owner problem :-(
    //$tmpf = tempnam('tmp', 'postnuke_');
    //$fp = fopen("$tmpf.php", w);
    $fp = @fopen('config/rte-config.php', w);
    if (!$fp) die (sprintf(_ERROR_FILE_OPEN,'rte-config.php','rte-config.php'));
    fwrite($fp, $content);
    fclose($fp);

// --------------------------------------------------------------------

		// build array for hidden files [Subjects-filemanager]
        $aBuffer = explode(',',$subhiddenfiles);
        $subhiddenfiles_store = '';
        for($i=0; $i < count($aBuffer); $i++)
        {
                $subhiddenfiles_store .= '"'.trim($aBuffer[$i]).'",';
        }

		// build array for hidden dirs [Subjects-filemanager]
        $aBuffer = explode(',',$subhiddendirs);
        $subhiddendirs_store = '';
        for($i=0; $i < count($aBuffer); $i++)
        {
                $subhiddendirs_store .= '"'.trim($aBuffer[$i]).'",';
        }

		// build array for editable file-extensions [Subjects-filemanager]
        $aBuffer = explode(',',$subeditextensions);
        $subeditextensions_store = '';
        for($i=0; $i < count($aBuffer); $i++)
        {
                $subeditextensions_store .= '"'.trim($aBuffer[$i]).'",';
        }

		// build array for upload image-file types [Subjects-filemanager]
        $aBuffer = explode(',',$subimageextensions);
        $subimageextensions_store = '';
        for($i=0; $i < count($aBuffer); $i++)
        {
                $subimageextensions_store .= '"'.trim($aBuffer[$i]).'",';
        }

    $content = "<?php // Generated: $d\n"
        ."// ----------------------------------------------------------------------\n"
                ."/**\n"
                ."This is the config-file for some defaults to setting up the Filemanager\n"
                ."The Filemanager is part of the Subjects-Module\n"
                ."\n"
                ."Name: sub-config.php\n"
                ."Description: DON'T EDIT THIS FILE MANUALLY. IT WILL BE GENERATED AUTOMATICALLY\n"
                ."Author: Stefan Khler (s.koehler@prowings.de)\n"
                ."**/\n"
        ."// ----------------------------------------------------------------------\n"
		."if(!isset($ModName))\n"
    	."\$ModName = basename( dirname( __FILE__ ) );\n"
		."//do you want to use WYSIWYG editor?\n"
		."\$subjectsconfig['wysiwygeditor'] = 0;\n"
		."//settings for file manager\n"
		."\$subjectsconfig['maxfilesize'] = '$submaxfilesize'; // max file size in bytes (1000000)\n"
		."\$subjectsconfig['hddspace'] = '$submaxhddspace'; // max total size of all files in directory (100000000)\n"
		."\$subjectsconfig['hiddenfiles'] = array($subhiddenfiles_store); // add any file names to this array which should remain invisible ('.htaccess')\n"
		."\$subjectsconfig['hiddendirs'] = array($subhiddendirs_store); // add any file names to this array which should remain invisible ('')\n"
		."\$subjectsconfig['editextensions'] = array($subeditextensions_store); // add the extensions of file types that you would like to be able to edit ('htm','html','txt','php')\n"
		."\$subjectsconfig['imageextensions'] = array($subimageextensions_store); // add the extensions of image file type ('jpg','jpeg','png','bmp','gif')\n"
		."\$subjectsconfig['pagespath'] = '$subpagespath'; //full path for modules/$ModName/pages folder with slash at the end ('/var/www/html/envo12/upload/sub/')\n"
        .'?'.'>'
    ;
    // I can't seem to get around the stupid PHP file owner problem :-(
    //$tmpf = tempnam('tmp', 'postnuke_');
    //$fp = fopen("$tmpf.php", w);
    $fp = @fopen('config/sub-config.php', w);
    if (!$fp) die (sprintf(_ERROR_FILE_OPEN,'sub-config.php','sub-config.php'));
    fwrite($fp, $content);
    fclose($fp);

// --------------------------------------------------------------------

    pnRedirect(pnModURL('rtemulti', 'admin', 'view'));

    return true;
}

/**
 * Main administration menu
 */
function rtemulti_adminmenu()
{
    // Create output object - this object will store all of our output so that
    // we can return it easily when required
    $output = new pnHTML();

    // Display status message if any.  Note that in future this functionality
    // will probably be in the theme rather than in this menu, but this is the
    // best place to keep it for now
    $output->Text(pnGetStatusMsg());
    $output->Linebreak(2);

    // Start options menu
    $output->TableStart(_RTEMULTI);
    $output->SetOutputMode(_PNH_RETURNOUTPUT);

    // Menu options.  These options are all added in a single row, to add
    // multiple rows of options the code below would just be repeated
    $columns = array();
    $columns[] = $output->URL(pnModURL('rtemulti',
                                       'admin',
                                       'new'),
                              _RTEMULTIADD);
    $columns[] = $output->URL(pnModURL('rtemulti',
                                       'admin',
                                       'view'),
                              _RTEMULTIVIEW);
    $columns[] = $output->URL(pnModURL('rtemulti',
                                       'admin',
                                       'modifyconfig'),
                              _RTEMULTIMODIFYCONFIG);
    $output->SetOutputMode(_PNH_KEEPOUTPUT);

    $output->SetInputMode(_PNH_VERBATIMINPUT);
    $output->TableAddRow($columns);
    $output->SetInputMode(_PNH_PARSEINPUT);

    $output->TableEnd();

    // Return the output that has been generated by this function
    return $output->GetOutput();
}

?>
