////////////////////////////////////////////////////////////////////////////////
//
// HTML Text Editing Component for hosting in Web Pages
// Copyright (C) 2001  Ramesys (Contracting Services) Limited
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU LesserGeneral Public License
// along with this program; if not a copy can be obtained from
//
//    http://www.gnu.org/copyleft/lesser.html
//
// or by writing to:
//
//    Free Software Foundation, Inc.
//    59 Temple Place - Suite 330,
//    Boston,
//    MA  02111-1307,
//    USA.
//
// Original Developer:
//
//        Austin David France
//        Ramesys (Contracting Services) Limited
//        Mentor House
//        Ainsworth Street
//        Blackburn
//        Lancashire
//        BB1 6AY
//        United Kingdom
//  email: Austin.France@Ramesys.com
//
// Home Page:    http://richtext.sourceforge.net/
// Support:      http://richtext.sourceforge.net/
//
////////////////////////////////////////////////////////////////////////////////
//
// Author(s):        leonreinders@hetnet.nl                                LEON
//
//                                Austin.France@Ramesys.com                        OZ
//
// History:
//
//        LEON        04-08-2001
//                        Initial Implementation
//
//        OZ                Disable/enable post button during view source mode.
//
////////////////////////////////////////////////////////////////////////////////

function init()
{
  var objName = window.name;
  var objID = objName.split('1_');
  var fID = objID[1];
  var objF=parent.frames[fID].window;
  objF.document.body.txtView = true;
  objF.document.body.onkeyup = function() {reset();};
  switchMode.disabled = false;
  applyOptions(OPTIONS);
  format[fID]='HTML';
  viewm[fID]=1;
}

function swapMode()
{
 //var objF=document.frames[fID];
  var objName = window.name;
  var objID = objName.split('1_');
  var fID = objID[1];
  var objF=parent.frames[fID].window;

 if(!objF){alert('Please click to select the editor');return}
 objF.focus()
 //alert('Frame-Name: '+window.name + btnPost.className)
 
switchMode.blur(); // htmlview
//if (switchMode.checked == true)
if(format[fID]=="HTML" && switchMode.checked == true)
 {

  ctlStyle.disabled = ctlFont.disabled = ctlSize.disabled = btnPost.disabled = true;
  btnPost.className = 'disabled';
  objF.document.body.style.fontFamily="Courier"
  objF.document.body.style.fontSize="10px"
  objF.document.body.innerText = codeSweeper();
  objF.document.body.innerHTML = ccParser(objF.document.body.innerHTML);
  objF.document.body.txtView = false;
  format[fID]="Text"
 }

 else
 {
  ctlStyle.disabled = ctlFont.disabled = ctlSize.disabled = btnPost.disabled = false;
  //objF.document.body.style.fontFamily='Arial'
  objF.document.body.style.fontFamily = objF.document.body.style.fontSize = "";
  btnPost.className = '';
  objF.document.body.style.color="#000000"
  objF.document.body.style.background=""
  objF.document.body.innerHTML=objF.document.body.innerText
  objF.document.body.txtView = true;
  format[fID]="HTML"
  viewm[fID]=1
 }
}

// setEditMode(): switch between html and textview
function setEditMode() {
  var objName = window.name;
  var objID = objName.split('1_');
  var fID = objID[1];
  var objF=parent.frames[fID].window;

        switchMode.blur(); // htmlview
        if (switchMode.checked == true) {
                ctlStyle.disabled = ctlFont.disabled = ctlSize.disabled = btnPost.disabled = true;
                btnPost.className = 'disabled';
                objF.document.style.fontFamily = "Courier";
                objF.document.style.fontSize = "10px";
                //RichEditor.txtView = false;
                //objF.document.innerText = codeSweeper();
                objF.document.innerHTML = ccParser(objF.document.innerHTML);
        } else {
                ctlStyle.disabled = ctlFont.disabled = ctlSize.disabled = btnPost.disabled = false;
                objF.document.style.fontFamily = objF.document.style.fontSize = "";
                btnPost.className = '';
                //RichEditor.txtView = true;
                objF.focus();
                objF.document.innerHTML = objF.document.innerText;
        }
}

// resetMode();
function resetMode(){
        if (switchMode.checked == true) {
                switchMode.click();
        }
}

// ccParser(): colorcode-parser for html-editing view
function ccParser(html) {

        html = html.replace(/@/gi,"_AT_");
        html = html.replace(/#/gi,"_HASH_");

        var htmltag = /(&lt;[\w\/]+[ ]*[\w\=\"\'\.\/\;\: \)\(-]*&gt;)/gi;
        html = html.replace(htmltag,"<span class=ccp_tag>$1</span>");

        var imgtag = /<span class=ccp_tag>(&lt;IMG[ ]*[\w\=\"\'\.\/\;\: \)\(-]*&gt;)<\/span>/gi;
        html = html.replace(imgtag,"<br><span style='color = #800080'>$1</span>");

        var formtag = /<span class=ccp_tag>(&lt;[\/]*(form|input|font){1}[ ]*[\w\=\"\'\.\/\;\: \)\(-]*&gt;)<\/span>/gi;
        html = html.replace(formtag,"<br><span style='color = #FF9900'>$1</span><br>");

        var tabletag = /<span class=ccp_tag>(&lt;[\/]*(table|tbody|th|tr|td){1}([ ]*[\w\=\"\'\.\/\;\:\)\(-]*){0,}&gt;)<\/span>/gi;
        html = html.replace(tabletag,"<span style='color = #008080'>$1</span>");

        var chartag = /<span class=ccp_tag>(&lt;[\/]*(b|i|u|strike){1}([ ]*[\w\=\"\'\.\/\;\:\)\(-]*){0,}&gt;)<\/span>/gi;
        html = html.replace(chartag,"<span style='color = #000099; font-weight=bold;'>$1</span>");

        var listtag = /<span class=ccp_tag>(&lt;[\/]*(ul|ol|li){1}([ ]*[\w\=\"\'\.\/\;\:\)\(-]*){0,}&gt;)<\/span>/gi;
        html = html.replace(listtag,"<span style='color = #993300'>$1</span>");

        var crtag = /<span class=ccp_tag>(&lt;[\/]*(p|br){1}([ ]*[\w\=\"\'\.\/\;\:\)\(-]*){0,}&gt;)<\/span>/gi;
        html = html.replace(crtag,"<span style='color = #FF0000'>$1</span>");

        //var Atag = /<span class=ccp_tag>(&lt;(\/a&gt;|[\W _\w\=\"\'\.\/\;\:\)\(-]&gt;){1})<\/span>/gi;
        var Atag = /<span class=ccp_tag>(&lt;\/a&gt;){1}<\/span>/gi;
        html = html.replace(Atag,"<span style='color = #008000'>$1</span>");

        var Atag = /<span class=ccp_tag>(&lt;a [\W _\w\=\"\'\.\/\;\:\)\(-]+&gt;){1,}<\/span>/gi;
        html = html.replace(Atag,"<br><span style='color = #008000'>$1</span>");

        var parameter = /=("[ \w\'\.\/\;\:\)\(-]+"|'[ \w\"\.\/\;\:\)\(-]+')/gi;
        html = html.replace(parameter,"=<span style='color = #0000FF';>$1</span>");

        var entity = /&amp;([\w]+);/gi;
        html = html.replace(entity,"<span style='color=#999999'>&amp;$1;</span>");

        var entity = /&nbsp;([\w]+);/gi;
        html = html.replace(entity,"<span style='color=#999999'>&nbsp;$1;</span>");

        var comment = /(&lt;\!--[\W _\w\=\"\'\.\/\;\:\)\(-]*--&gt;)/gi;
        html = html.replace(comment,"<br><span style='color = #999999';>$1</span>");

        html = html.replace(/_AT_/gi,"@");
        html = html.replace(/_HASH_/gi,"#");

        return html;
}
// applyOptions(): This takes the passed options string and actions them.
// Called during the init process.
function applyOptions(str)
{

   var options = str.split(";");
   for (var i = 0; i < options.length; i++) {
      var eq = options[i].indexOf('=');
      var on = eq == -1 ? true : "yes;true;1".indexOf(options[i].substr(eq+1).toLowerCase()) != -1;
      var name = eq == -1 ? options[i] : options[i].substr(0,eq);
      var el = document.all("feature" + name);
      if (el) {
         el.runtimeStyle.display = (on ? 'inline' : 'none');
      } else {
         //if (!RichEditor.aOptions) RichEditor.aOptions = new Array;
         //RichEditor.aOptions[name] = on;
      }
   }
}

