<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Filename: modules/Subjects/admin/modules/filemanager.php
// Original Author of file: Quentin O'Sullivan (http://www.qto.com/fm)
// Modified by: Jaroslaw Gilewski (http://www.yagi.com.pl)
// Modified and ported to eNvolution TiMax timax@envolution.com
// Purpose of file: File manager for the Subjects module
// ----------------------------------------------------------------------

global $HTTP_POST_FILES, $edit, $view, $save, $mkdir, $upload, $delete, $pathext,
       $content, $bgcolor2, $bgcolor3, $subjectsconfig;

// set these configuration variables
$maxfilesize = $subjectsconfig['maxfilesize']; // max file size in bytes
$hddspace = $subjectsconfig['hddspace']; // max total size of all files in directory
$hiddenfiles = $subjectsconfig['hiddenfiles']; // add any file names to this array which should remain invisible
$hiddendirs = $subjectsconfig['hiddendirs']; // add any file names to this array which should remain invisible
$editextensions = $subjectsconfig['editextensions']; // add the extensions of file types that you would like to be able to edit
$imageextensions = $subjectsconfig['imageextensions']; // add the extensions of image file type
$pagespath = $subjectsconfig['pagespath']; //full path for modules/$ModName/pages folder

/********************************************************************/

function dirsize($dir)
// calculate the size of files in $dir
{
    $dh = opendir($dir);
    $size = 0;
    while (($file = readdir($dh)) !== false)
        if ($file != "." and $file != "..")
        {
            $pagespath = $dir."/".$file;
            if (is_dir($pagespath))
                $size += dirsize("$pagespath/");
            elseif (is_file($pagespath))
                $size += filesize($pagespath);
        }
    closedir($dh);
    return $size;
}

if($view){ // if an edit link was clicked
    global $bgcolor1, $bgcolor2;

    $file = $pagespath.$pathext.$view;
    $fp = fopen($file, "r");
    $content = fread($fp, filesize($file));
    fclose($fp);

    $dotpos = strrpos($file, ".");
    foreach($imageextensions as $viewimage)
    {
        $ext = substr($file, ($dotpos+1));
        if(strcmp($ext, $viewimage) == 0)
            $content = "<center><img src=\"modules/$ModName/pages/$pathext".basename($file)."\"></center>";
    }


    echo "<center><font class=\"pn-title\"><b>"._VIEWFILECONTENT."</b></font><br><br>"
        ."<font class=\"pn-normal\"><b>$pathext$view</b></font></center><br><br>"
        ."<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"0\" bgcolor=\"$bgcolor2\"><tr><td>\n"
        ."<table width=\"100%\" border=\"0\" cellspacing=\"1\" cellpadding=\"8\" bgcolor=\"$bgcolor1\"><tr><td>\n"
        ."$content"
        ."</td></tr></table></td></tr></table><br>\n"
        .""._BACKTOFM;
}
elseif($edit){ // if an edit link was clicked
    $fp = fopen($pagespath.$pathext.$edit, "r");
    $content = fread($fp, filesize($pagespath.$pathext.$edit));
    fclose($fp);

    echo "<center><font class=\"pn-title\"><b>"._EDITFILECONTENT."</b></font><br><br>"
        ."<font class=\"pn-normal\"><b>$pathext$edit</b></font></center><br><br>"
        ."<form name=\"contentform\" method=\"post\" action=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager\">"
        ."<b>"._FILECONTENT."</b><br>"
        ."<textarea name=\"content\" cols=\"60\" rows=\"10\" >$content</textarea>";

    echo "<br><br><input type=\"submit\" value=\""._SAVEFILECONTENT."\"><br>"
        ."<input type=\"hidden\" name=\"save\" value=\"$edit\">"
        ."<input type=\"hidden\" name=\"pathext\" value=\"$pathext\">"
        ."</form><br>"
        .""._BACKTOFM;
}
else{
    if($save){ // if the save button was pressed on the edit screen
        $content = stripslashes($content);
        $fp = fopen($pagespath.$pathext.$save, "w");
        fwrite($fp, $content);
        fclose($fp);
    }

    $hddtotal = dirsize($pagespath); // get the total size of all files in the directory including any sub directorys

    if($upload != 'none' && $upload != ''){ // if the upload button was pressed
        if($HTTP_POST_FILES['upload']['name']){ // if a file was actually uploaded
            $HTTP_POST_FILES['upload']['name'] = str_replace("%","",$HTTP_POST_FILES['upload']['name']);  // remove any % signs from the file name
            // if the file size is within allowed limits
            if($HTTP_POST_FILES['upload']['size'] > 0 && $HTTP_POST_FILES['upload']['size'] < $maxfilesize){
                // if adding the file will not exceed the maximum allowed total
                if(($HDDTotal + $HTTP_POST_FILES['upload']['size']) < $hddspace)
                    // put the file in the directory
                    move_uploaded_file($HTTP_POST_FILES['upload']['tmp_name'], $pagespath.$pathext.$HTTP_POST_FILES['upload']['name']);
                else
                    $msg = "<font color=\"red\">"._NOFREESPACEERROR."</font><br>";
            }else{
                $MaxKB = $maxfilesize/1000; // show the max file size in Kb
                $msg =  "<font color=\"red\">"._FILEGREATERTHANMAX1.$MaxKB._FILEGREATERTHANMAX2."</font><br>";
            }
        }else
            $msg =  "<font color=\"red\">"._PRESSBROWSEBEFOREUPLOAD."</font><br>";
    }elseif($delete){ // if the delete button was pressed
        // delete the file or directory
        if(is_dir($pagespath.$pathext.$delete)){
            $result = @rmdir($pagespath.$pathext.$delete);
            if($result == 0)
                $msg = "<font color=\"red\">"._FOLDERCOULDNOTBEDELETED."</font><br>";
        }else{
            $result = unlink($pagespath.$pathext.$delete);
            if($result == 0)
                $msg = "<font color=\"red\">"._FILECOULDNOTBEDELETED."</font><br>";
        }
    }elseif($mkdir){
        $result = @mkdir($pagespath.$pathext.$mkdir, 0700);
        if($result == 0)
            $msg = "<font color=\"red\">"._FOLDERCOULDNOTBECREATED."</font><br>";
    }

    $freespace = number_format((float) (($hddspace - $hddtotal)/1000), 2, '.', ' '); // type cast as an int
    $hddtotal = number_format((float) ($hddtotal/1000), 2, '.', ' '); // convert to Kb instead of bytes and type cast it as an int
    $hddspace = number_format((float) ($hddspace/1000), 2, '.', ' '); // convert to Kb instead of bytes and type cast it as an int
    $maxfilesizekb = number_format((float) ($maxfilesize/1000), 2, '.', ' '); // convert to Kb instead of bytes and type cast it as an int

    // build the html that makes up the file manager
    // the $filemanager variable holds the first part of the html
    // including the form tags and the top 2 heading rows of the table which
    // dont display files
    echo "<center><font class=\"pn-title\"><b>"._FILEMANAGER."</b></font><br>"
        ."<table border=\"0\" cellspacing=\"0\" cellpadding=\"20\">"
        ."<tr><td>$msg"
        ."<form method=\"post\" action=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager\" enctype=\"multipart/form-data\">"
        ."<b>"._NEWDIR."</b>&nbsp;<input type=\"text\" name=\"mkdir\" size=\"25\">&nbsp;<input type=\"submit\" value=\""._MAKEDIR."\"><br>"
        ."<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"$maxfilesize\">"
        ."<b>"._NEWFILE."</b>&nbsp;<input type=\"file\" name=\"upload\" size=\"25\">&nbsp;"
        ."<input type=\"submit\" value=\""._UPLOADFILE."\">"
        ."<input type=\"hidden\" name=\"pathext\" value=\"$pathext\">"
        ."</form>"
        ."<table border=\"0\" cellspacing=\"0\" cellpadding=\"2\" align=\"center\">"
        ."<tr>";
    if($pathext != "")
        echo "<th colspan=\"4\" bgcolor=\"$bgcolor2\">$pathext</th>"
            ."</tr><tr>"
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."<td height=\"1\"></td>"
            ."</tr><tr>";
    echo "<th bgcolor=\"$bgcolor2\"></th>"
        ."<th bgcolor=\"$bgcolor2\"><b>&nbsp;"._FILENAME."&nbsp;</b></th>"
        ."<th bgcolor=\"$bgcolor2\"><b>&nbsp;"._FILESIZE."&nbsp;</b></th>"
        ."<th bgcolor=\"$bgcolor2\"><b>&nbsp;"._FUNCTIONS."&nbsp;</b></th>"
        ."</tr><tr>"
        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
        ."</tr>";

    // if the current directory is a sub directory show a back link to get back to the previous directory
    if($pathext)
    {
        $prevpathext = substr($pathext, 0, -1);
        $slashpos = strrpos($prevpathext, "/");
        if($slashpos == 0)
            $prevpathext = "";
        else
            $prevpathext = substr($prevpathext, 0, ($slashpos+1));

        echo "<tr>"
            ."<td align=\"center\" bgcolor=\"$bgcolor3\">&nbsp;<img src=\"modules/$ModName/images/arrowicon.gif\">&nbsp;</td>"
            ."<td>&nbsp;<a href=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager&pathext=$prevpathext\">[..]</a>&nbsp;</td>"
            ."<td bgcolor=\"$bgcolor3\"></td>"
            ."<td>&nbsp;</td>"
            ."</tr>"
            ."<tr>"
            ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
            ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
            ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
            ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
            ."</tr>";
    }

    // build the table rows which contain the file information
    $newpath = substr($pagespath.$pathext, 0, -1);   // remove the forward or backwards slash from the path

    $dir = @opendir($newpath); // open the directory
    while($file = readdir($dir)) // loop once for each dir in the directory
    {
        // if the name is not a '.' or '..' and is directory
        if($file != "." && $file != ".." && is_dir($pagespath.$pathext.$file))
        {
            $match = 0;
            foreach($hiddendirs as $name) // for each value in the hidden dirs array
            {
                if($file == $name) // check the name is not the same as the hidden dir name
                    $match = 1;     // set a flag if this name is supposed to be hidden
            }
            if(!$match) // if there were no matches the dir should not be hidden
            {
                    $filedata = stat($pagespath.$pathext.$file); // get some info about the dir

                    // create some html for a link to delete dir
                    $deletelink = "<a href=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager&delete=$file&pathext=$pathext\">"._DELETEFILE."</a>";
                    $filename = "<a href=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager&pathext=$pathext$file/\">$file</a>";
                    $fileicon = "&nbsp;<img src=\"modules/$ModName/images/foldericon.gif\">&nbsp;";

                    echo "<tr>"
                        ."<td align=\"center\" bgcolor=\"$bgcolor3\">$fileicon</td>"
                        ."<td>&nbsp;$filename&nbsp;</td>"
                        ."<td align=\"right\" bgcolor=\"$bgcolor3\">&nbsp;</td>"
                        ."<td>$deletelink</td>"
                        ."</tr>"
                        ."<tr>"
                        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
                        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
                        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
                        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
                        ."</tr>";
            }
        }
    }
    closedir($dir); // now that all the rows have been built close the directory

    $dir = @opendir($newpath); // open the directory
    while($file = readdir($dir)) // loop once for each name in the directory
    {
        // if the name is not a directory
        if($file != "." && $file != ".." && !is_dir($pagespath.$pathext.$file))
        {
            $match = 0;
            foreach($hiddenfiles as $name) // for each value in the hidden files array
            {
                if($file == $name) // check the name is not the same as the hidden file name
                    $match = 1;     // set a flag if this name is supposed to be hidden
            }
            if(!$match) // if there were no matches the file should not be hidden
            {
                    $filedata = stat($pagespath.$pathext.$file); // get some info about the file

                    // find out if the file is one that can be edited
                    $editlink = "";
                    $viewlink = "";

                    $dotpos = strrpos($file, ".");
                    foreach($editextensions as $editext){
                        $ext = substr($file, ($dotpos+1));
                        if(strcmp($ext, $editext) == 0){
                            $editlink = "&nbsp;<a href=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager&edit=$file&pathext=$pathext\">"._EDITFILE."</a>&nbsp;";
                            $viewlink = "&nbsp;<a href=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager&view=$file&pathext=$pathext\">"._VIEWFILE."</a>&nbsp;";
                        }
                    }
                    foreach($imageextensions as $imgext){
                        $ext = substr($file, ($dotpos+1));
                        if(strcmp($ext, $imgext) == 0)
                            $viewlink = "&nbsp;<a href=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager&view=$file&pathext=$pathext\">"._VIEWFILE."</a>&nbsp;";
                    }

                    // create some html for a link to delete files
                    $deletelink = "<a href=\"admin.php?module=".$GLOBALS['module']."&amp;op=filemanager&delete=$file&pathext=$pathext\">"._DELETEFILE."</a>";
                    $filename = $file;
                    $fileicon = "&nbsp;<img src=\"modules/$ModName/images/fileicon.gif\">&nbsp;";

                    echo "<tr>"
                        ."<td align=\"center\" bgcolor=\"$bgcolor3\">$fileicon</td>"
                        ."<td>&nbsp;$filename&nbsp;</td>"
                        ."<td bgcolor=\"$bgcolor3\">&nbsp;$filedata[7]&nbsp;</td>"
                        ."<td>$deletelink";
                    if($editlink != "")
                        echo " | $editlink";
                    if($viewlink != "")
                        echo " | $viewlink";
                    echo "</td></tr><tr>"
                        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
                        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
                        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
                        ."<td height=\"1\" bgcolor=\"$bgcolor2\"></td>"
                        ."</tr>";
            }
        }
    }
    closedir($dir); // now that all the rows have been built close the directory
    echo "</table><br>"
        ."<b>"._TOTALSPACE.":</b> $hddspace Kb<br><b>"._MAXFILESIZE.":</b> $maxfilesizekb Kb<br>"
        ."<b>"._FREESPACE.":</b> $freespace Kb<br><b>"._USEDSPACE.":</b> $hddtotal Kb<br>";
    echo "</td></tr></table></center>"; // add some closing tags to the $content variable
}
?>