<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// File: $Id: TopCenter.php,v 1.3 2003/02/11 03:23:12 timax Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (madhatter7@envolution.com)
// http://www.envolution.com
// Envolution Content Management System - http://www.envolution.com
//
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please read the docs/license.txt or visit
// http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Filename:    Encompass Theme Engine      Encompass.inc
// Original Author of file:     Brian K. Virgin (aka 'MADHATter7')
// Purpose of file:     Main file for the Theme Engine
// ----------------------------------------------------------------------------
// Changelog
// 12-03-2002: MADHATter7 - initial Addon release
// ----------------------------------------------------------------------------

class TopCenter extends Encompass {

        // Internal Variables
        var $DTS;                                        // instance of the template system
        var $DTS_attrib;                        // template system global config
        var $totalcells;

        var $skins;

        // This defines which sidblocks will be displayed
        // 'cell number' => "block title"
        // You may also use funtion output in this array
        // 'cell number' => "function name"
          var $blocks = array(
                '1'        => "Who's Online",
                '8'        => "Chi  On-line",
                '9'        => "Wer ist gerade online",
                '10'        => "Qui est en ligne",
                '2'        => "Search Box",
                '5'        => "Cerca",
                '6'        => "Recherche",
                '7'        => "Suche",
                '3'        => "Karma",
                '4'        => "Discussions"
);

///////////////////////////////////////////////////////////////////////////////
// BEGIN MAIN ADDON METHODS
///////////////////////////////////////////////////////////////////////////////
// function:        Encompass_TopCenter()
// purpose:                constructor

function TopCenter() {

        // get Encompass Class Name
        $par = get_parent_class($this);
        $this->totalcells = sizeof($this->blocks);
}

// function:        addons_topcenter_init()
// purpose:                Init the TopCenter Zone
function addons_topcenter_init() {
        //global $this->DTS;
        $zone = "topcenter";

        // Register the Template function
        $this->DTS->register_function("TOPCELLS","topcells");
        if (!empty($this->skins[$zone])) {
                $this->DTS->display($this->skins[$zone]);
        }
}

// function:        addons_topcenter_display()
// purpose:                display the TopCenter Contents
function addons_topcenter_display($cell) {
global $blocks_modules;
// New [0.710] methods
        list ($dbconn) = pnDBGetConn();
        $pntable = pnDBGetTables();
        $currentlang = pnUserGetLang();

        if ($cell <= $this->totalcells) {
                $theblock = $this->blocks[$cell];
        } else {
                echo "Cell config error, Cell: $cell is<br />";
                echo "higher than Max: ".$this->totalcells."<br />";
                return;
        }
        if (function_exists($theblock)) {
                $theblock();
        } else {
                if (pnConfigGetVar('multilingual') == 1) {
                        $column = &$pntable['blocks_column'];
                        $querylang = "AND ($column[blanguage]='$currentlang' OR $column[blanguage]='')";
                } else {
                        $querylang = '';
        }
        $column = &$pntable['blocks_column'];
        $query = "SELECT $column[bid] AS bid, $column[bkey] AS bkey,
                                        $column[title] AS title, $column[content] AS content,
                                        $column[url] AS url, $column[position] AS position,
                                        $column[weight] AS weight, $column[active] AS active,
                                        $column[refresh] AS refresh, $column[mid] AS mid,
                                        $column[last_update] AS unix_update,
                                        $column[blanguage] AS blanguage
                                FROM $pntable[blocks] WHERE $column[title]='"
                                        .pnVarPrepForStore($theblock)."' $querylang LIMIT 1";

        $result = $dbconn->Execute($query);
        if ($dbconn->ErrorNo() != 0) {
                $this->db_error((__FILE__), (__LINE__), 'addons_topcenter_display',
                $query, $dbconn->ErrorNo(), $dbconn->ErrorMsg());
        } else {
                if (!$result->EOF) {
                        $row = $result->GetRowAssoc(false);
                        $result->Close();
                        $row['unix_update'] = $result->UnixTimeStamp($row['unix_update']);

                        // New-style blocks
                if ($row['mid'] == 0) {
                        $modname = "Core";
                } else {
                        $modinfo = pnModGetInfo($row['mid']);
                        $modname = $modinfo['name'];
                }

                // Set as TopCenter Block
                $row['position'] = 't';

                echo pnBlockShow($modinfo['name'], $row['bkey'], $row);
                        }
                }
        }
}

// function:    db_error
// purpose:     generic db error routine
function db_error($file='', $line='', $function='', $query='', $ErrorNo, $ErrorMsg) {
        echo "<br />"
        ."<table width=\"100%\" algin=\"center\" cellpadding=\"1\" "
        ."cellspacing=\"0\" border=\"0\">"
        ."<tr><td colspan=\"2\" align=\"center\">"
        ."<span class=\"pn-title\"><u>DB Error $ErrorNo</u>"
        ."</span></td>"
        ."</tr><tr>"
        ."<td><span class=\"pn-normal\"><b>File:</b>"
        ."</span></td><td><span class=\"pn-sub\">$file</span></td>"
        ."</tr><tr>"
        ."<td><span class=\"pn-normal\"><b>Function:</b>"
        ."</span></td><td><span class=\"pn-sub\">$function</span></td>"
        ."</tr><tr>"
        ."<td><span class=\"pn-normal\"><b>Line No:</b>"
        ."</span></td><td><span class=\"pn-sub\">$line</span></td>"
        ."</tr><tr>"
        ."<td><span class=\"pn-normal\"><b>Query:</b>"
        ."</span></td><td><span class=\"pn-sub\">$query</span></td>"
        ."</tr><tr>"
        ."<td><span class=\"pn-normal\"><b>Message:</b>"
        ."</span></td><td><span class=\"pn-sub\">$ErrorMsg</sapn></td>"
        ."</tr></table>";
        exit;
}
}        // END Class

///////////////////////////////////////////////////////////////////////////////
// BEGIN ADDON FUNCTIONS
///////////////////////////////////////////////////////////////////////////////
// function:        topcells()
// purpose:                DTS function, used as a wrapper to properly call
//                                Sideblocks in the Top CenterBlock
function topcells($params) {
        $topCenter = new TopCenter;
        extract($params);
        if (!empty($cell)) {
                $topCenter->addons_topcenter_display($cell);
        }
}
?>
